dag.search <- function(d,m,el,steps=100)
  .Call("BNSL_SearchForDAG",d,as.integer(m),as.integer(el),as.integer(steps))
dag.sample <- function(d,m,n=c(1000,1000),thin=1,start=NULL)
  .Call("BNSL_StructureMCMC",d,as.integer(m),as.integer(n),as.integer(thin),start)
dag.from.orders <- function(d,m,o,n=100)
  .Call("BNSL_DagSampleFromOrders",d,as.integer(m),o,as.integer(n))
dag.from.orders.is <- function(d,m,o,n=100)
  .Call("BNSL_DagISampleFromOrders",d,as.integer(m),o,as.integer(n))
dag.from.order <- function(d,m,o,n)
  .Call("BNSL_SampleDagFromOrder",d,as.integer(m),as.integer(o),as.integer(n))
dag.from.order.is <- function(d,m,o,n)
  .Call("BNSL_ISampleDagFromOrder",d,as.integer(m),as.integer(o),as.integer(n))
dags.to.dagSample <- function(dags) .Call("BNSL_DagMakeSample");
raw.to.dag <- function(raw,n)
  .Call("BNSL_RawToDag",raw,as.integer(n),DUP=FALSE)
consistent.dag <- function(dag,orders)
  .Call("BNSL_ConsisntentOrders",as.numeric(dag),orders,DUP=FALSE)


setMethod("show","dagSample",function(object) {
  cat("Sample of ")
  cat(sum(object@n))
  cat(" (")
  cat(length(object@n))
  cat(" species)\n")
})

score.features.dag <- function(dagSample)
  .Call("BNSL_FeatureScoreFromDagSample",dagSample)


dag.gibbs <- function(d,m,steps=100)
  .Call("BNSL_GibbsDAG",d,as.integer(m),as.integer(steps))

sample.dag <- function(d,m,o=sample(1:vars(d)))
  .Call("BNSL_GraphFromOrder",d,as.integer(m),as.integer(o))
score.dag  <- function(d,m,dag,
                       orders,scores)
  .Call("BNSL_CalculateGraphScore",d,as.integer(m),dag,orders,as.numeric(scores))

setClass("dag",representation(rep="raw",hash="integer",score="numeric"))
order.cond <- function(object,order,d,m) {
  .Call("BNSL_GraphProbForOrder",d,as.integer(m),object,as.integer(order))
}
          
          



                              
