#setClass("fastdb","externalptr")
"[<-.fastdb" <- function(x,i,j,...,value) .Call("BNSL_FastDBSet",x,as.integer(i),as.numeric(value))
"[.fastdb"   <- function(x,i,j,...,drop) {
  r = .Call("BNSL_FastDBGet",x,as.integer(i))
  if(missing(j)) r else r[j]
}
fast.db <- function(vars,file,cache=c(0,15*1024*1024,0)) {
  .Call("BNSL_MakeFastDB",file,as.integer(vars),as.integer(cache))
}

fast.sync <- function(db) invisible(.Call("BNSL_FastDBSync",db))

fast.score.order <- function(db,order,k=3)
  .Call("BNSL_FastDBScoreOrder",db,as.integer(order),as.integer(k))
fast.order.sample <- function(d,m,N,H=-Inf,T=1,q=0.10,S=.05,X=NULL,order=NULL,mode="int",use.max=FALSE) {
  ret = new("sample",temperature=as.numeric(T),energy=as.numeric(H))
  .Call("BNSL_FastOrderSample",
        d,as.integer(m),as.integer(N),
        order,
        ret,as.numeric(q),X,as.numeric(S),as.logical(use.max))
}
fast.order.pt <- function(d,m,N,T=c(1),q=0.10) {
  ret = new("sample",temperature=as.numeric(T))
  .Call("BNSL_FastOrderPT",
        d,as.integer(m),as.integer(N),ret,as.numeric(q))
}

fast.dag.sample <- function(db,orders,k=3,mult=100)
  .Call("BNSL_FastDagSample",db,orders,as.integer(k),as.integer(mult))

fast.ub.sample <- function(d,m,objects)
  .Call("BNSL_FastCorrected",d,as.integer(m),objects)
fast.od.sample <- function(d,m,N,H=-Inf,T=1,q=0.10,S=.05,X=NULL,dag=NULL,cand=NULL) {
  ret = new("sample",temperature=as.numeric(T),energy=as.numeric(H))
  .Call("BNSL_FastODSample",
        d,as.integer(m),as.integer(N),
        dag,
        ret,as.numeric(q),X,as.numeric(S),cand)
}

fast.pt.sample <- function(d,m,N,T,S=.1,cand=NULL) {
  .Call("BNSL_FastPTSample",
        d,as.integer(m),as.integer(N),as.numeric(T),as.numeric(S),cand)
}


fast.od.anneal <- function(d,m,N,T=c(1,10),sched="log",dag=NULL,cand=NULL) {
  sched = match(sched,
    c("linear","power","ratio","log","sigmoid","cos","tanh","cosh","exp","exp2"))
  .Call("BNSL_FastODAnneal",
        d,as.integer(m),as.integer(N),as.numeric(T),
        as.integer(sched),dag,cand)
}
fast.dag.opt <- function(d,m,N,dag=NULL,cand=NULL)
  .Call("BNSL_FastOptimize",d,as.integer(m),as.integer(N),dag,cand)
fast.dag.wrp <- function(d,m,os,N=100,sigma=.90) .Call("BNSL_FastDagSampleWRP",d,os,as.integer(m),as.integer(N),as.numeric(sigma))
