setClass("order.pop",representation("orders"="list",
                                    "scores"="numeric",
				    "max.parents"="integer",
				    "qM"="numeric",
                                    "xover"="integer",
                                    "xover.accept"="numeric",
                                    "accept.mat"="numeric",
                                    "temp.ladder"="numeric",
				    "state"="list"))
setMethod("show","order.pop",function(object) {
  cat("Order sampler\n\n")
  cat(length(object@orders),"samples\n")
  print(t(apply(object@scores,1,range)))
  cat("Temperature Ladder:\n")
  print(object@temp.ladder)
  cat("Crossover Acceptance:\n")
  print(object@xover.accept)
  cat("Exchange Acceptance:\n")
  zz = cbind(1:(length(object@temp.ladder)-1),2:length(object@temp.ladder))
  accept.list = object@accept.mat[zz]
  names(accept.list) <- apply(zz,1,paste,collapse=" <-> ")
  print(accept.list)
  invisible(object)
})

setMethod("plot",signature(x="order.pop",y="missing"),function(x,y,...) {
  l = length(x@scores[1,])
  opar = par(mfrow=c(1,2))
  plot(x@scores[1,],type="l",main="Target Distribution Sample Chain")
  hist(x@scores[1,as.integer(l/2):l],main="Histogram of Latter Half")
  par(opar)
})

order.genetic <- function(d,m,n,temp.ladder=c(1,2,3,4,5),qm=0.25,
	start=NULL,xover="CX",
	mode="int")
  .Call("BNSL_EMC",d,as.integer(m),
        match(mode,c("int","max","min")),
        as.integer(n),
        qm,as.numeric(temp.ladder),
	start,
        if(is.character(xover)) match(xover,c("CX","ISX","ISXU","ISXA")) else as.integer(xover))

order.genetic.cont <- function(d,n,pop,mode="int")
  order.genetic(d,pop@max.parents,n,pop@temp.ladder,pop@qM,pop@state,pop@xover,mode)


t.ladder <- function(chains,r=1.5,t0=1) 
  c(t0,sapply(1:chains,function(...) t0 <<- t0*r))

