#
# Cooper-Herskovitz Metric (from the K2) algorithm
# with a uniform prior
K2.slow.metric <- function(x) {
	N.ij <- ftable(x)
        lgamma(ncol(N.ij))-sum(lgamma(rowSums(N.ij)+ncol(N.ij)))+sum(lgamma(N.ij+1))
}


K2.metric <- function(tbl,i,j,alpha=0)
  .Call("BNSL_K2",tbl,as.integer(i),as.integer(j),
        as.numeric(alpha),DUP=FALSE)

BDeu.metric <- function(tbl,i,j,alpha=1,skip=NULL,lag=0)
  .Call("BNSL_BDeu",tbl,as.integer(i),as.integer(j),
        alpha,skip,lag,DUP=FALSE)

BIC.metric <- function(tbl,i,j)
  .Call("BNSL_BIC",tbl,as.integer(i),as.integer(j),DUP=FALSE)

MDL.metric <- function(tbl,i,j)
  .Call("BNSL_MDL",tbl,as.integer(i),as.integer(j),DUP=FALSE)

Laplace.metric <- function(tbl,i,j)
  .Call("BNSL_Laplace",tbl,as.integer(i),as.integer(j),DUP=FALSE)
