#
# Sample orders
#
order.sample  = function(d,m,N,H=-Inf,T=1,q=0.10,S=.05,
			X=NULL,order=NULL,mode="int") {
  H    = as.numeric(H)
  T    = as.numeric(T)
  q    = as.numeric(q)
  S    = as.numeric(S)
  .Call("BNSL_OrderEquiEnergySample",
        d,
        as.integer(m),
        match(mode,c("int","max","min")),
        as.integer(N),as.integer(order),H,T,q,X,S,DUP=FALSE)
}
setMethod("show","sample",function(object) {
  cat("Sample of ")
  cat(length(object@score))
  cat(" objects [")
  cat(paste(range(object@score)))
  cat("]\n")
})
setMethod("show","chain.diag",function(object) {
  total = object@energy.steps + object@swap.steps + object@cut.steps
  if(object@energy.steps > 0) {
    cat("Equi-Energy Jump Acceptance Rate: ")
    cat(object@energy.rate)
    cat("\n")
    cat("Equi-Energy Jump Attempt Rate: ")
    cat(object@energy.steps/total)
    cat("\n")
  }

  if(object@swap.steps > 0) {
    cat("Swap Acceptance Rate: ")
    cat(object@swap.rate)
    cat("\n")
    cat("Swap Attempt Rate: ")
    cat(object@swap.steps/total)
    cat("\n")
  }

  if(object@cut.steps > 0) {
    cat("Cut Acceptance Rate: ")
    cat(object@cut.rate)
    cat("\n")
    cat("Cut Attempt Rate: ")
    cat(object@cut.steps/total)
    cat("\n")
  }      
  
})
