#ifndef _h_bruteforce_
#define _h_bruteforce_

#include "common.h"
#include <db.h>
#include "scoring.h"


struct anode_pool;
typedef struct anode_pool *anode_pool;

typedef struct anode {
  int    value;
  struct anode *next;
} *anode;

anode anode_insert(anode_pool,anode,int);
anode anode_remove(anode_pool,anode,int);
void  anode_clear(anode_pool,anode);

struct anode_pool {
  int   max,fp;			/* Maximum nodes, freelist */
  anode nodes;
  int*  freelist;
};

void anode_pool_init(anode_pool,int,int);
anode anode_alloc(anode_pool,int);
void  anode_free(anode_pool,anode);


typedef struct anode_graph {
  int n;
  struct anode_pool pool;
  char  *graph;
  int   *parents;
  int   *color;
  int   *order;
  anode *vertices;
} *anode_graph;

anode_graph anode_graph_create(int n,int m_p);
void anode_graph_add_edge(anode_graph g,int from,int to);
void anode_graph_remove_edge(anode_graph g,int from,int to);
void anode_graph_clear_parents(anode_graph g,int to);


/* Parent set iterator for a particular 
   vertex */
typedef struct pset_iter {
  int    n;			/* Number of vertices */
  int    vertex;		/* Destination Vertex to Manage */
  int    *P;			/* Twiddle scratch area */
  int    p,m_p;			/* Parent Count Management */
  int    x,y,z;			/* Twiddle operators */
  int    cont;			/* Continuation Setting */
} *pset_iter;

pset_iter pset_iter_create(int,int,int);
void pset_iter_reset(pset_iter);
int  pset_iter_next(pset_iter,anode_graph);


#endif
