#include <Rdefines.h>
#include "common.h"
#include "bitstring.h"

SEXP toEdgeList(SEXP dag,int n) {
  char *d = RAW(dag);
  SEXP  ret;
  PROTECT(ret = allocVector(VECSXP,n));
  int i;
  for(i=0;i<n;i++) {
    int j;int c =0;
    char *d = RAW(dag);
    for(j=0;j<n;j++) {
      if(bit_test(d,i)) c++;
      d += bitstr_size(n);
    }
    SEXP s;
    PROTECT(s = allocVector(INTSXP,c));
    int x=0;
    d = RAW(dag);
    for(j=0;j<n;j++) {
      if(bit_test(d,i)) INTEGER(s)[x++] = j;
      d += bitstr_size(n);
    }
    SET_VECTOR_ELT(ret,i,s);
    UNPROTECT(1);
  }
  UNPROTECT(1);
  return ret;
}

#define PUSH(I) q[t++] = I
#define POP     q[--t]

SEXP topoSort(SEXP graph) {
  int n = length(graph);
  int*c = (int*)R_alloc(sizeof(int),n);
  int*q = (int*)R_alloc(sizeof(int),n);
  int t = 0,s = 0;

  memset(c,0,sizeof(int)*n);
  int i;
  for(i=0;i<n;i++) {
    int j;
    SEXP x = VECTOR_ELT(graph,i);
    for(j=0;j<length(x);j++) c[INTEGER(x)[j]]++;
  }
  for(i=0;i<n;i++) if(c[i]==0) PUSH(i);

  SEXP ret;
  PROTECT(ret = allocVector(INTSXP,n));
  while(t) {
    int  j,y = POP;
    
    INTEGER(ret)[s++] = y;
    SEXP x = VECTOR_ELT(graph,y);
    for(j=0;j<length(x);j++) 
      if(--c[INTEGER(x)[j]] == 0) PUSH(INTEGER(x)[j]);
  }
  if(s<n) error("Graph is not acyclic");
  UNPROTECT(1);
  return ret;
}

SEXP orderEdges(SEXP dag) {
  //1. Perform a topological sort
  SEXP topo = topoSort(dag);
  PROTECT(topo);
  int i,edgeC = 0;
  for(i=0;i<length(dag);i++) edgeC += length(VECTOR_ELT(dag,i));
  SEXP edges;
  PROTECT(edges = allocVector(VECSXP,edgeC));
  //2. Set i=0
  i=0;
  UNPROTECT(2);
  return edges;
}


