#include "common.h"
#include <Rdefines.h>
#include <db.h>
#include "scoring.h"

#define COPY_SLOT(X,slotName,Y) { \
    SEXP x; \
    PROTECT(x = duplicate(GET_SLOT(Y,install(slotName)))); \
    SET_SLOT(X,install(slotName),x);			   \
    UNPROTECT(1);					   \
  }

SEXP BNSL_MakeLandscape(SEXP sample,SEXP part,SEXP I,SEXP H) {
  char *vmax = vmaxget();
  int i,j,k,n,first = INTEGER(I)[0]-1;
  double h          = asReal(H);
  int *counts,*index;
  SEXP ls,score,rings;
  PROTECT(ls = NEW_OBJECT(MAKE_CLASS("landscape"))); /*1*/
  
  /* Copy duplicated slots */
  COPY_SLOT(ls,"score",sample);
  COPY_SLOT(ls,"population",sample);
  COPY_SLOT(ls,"temperature",sample);
  COPY_SLOT(ls,"energy",sample);
  COPY_SLOT(ls,"diag",sample);
  SET_SLOT(ls,install("partition"),duplicate(part));
  
  
  score = GET_SLOT(ls,install("score"));
  counts = (int*)R_alloc(sizeof(int),length(part)+1);
  memset(counts,0,sizeof(int)*(length(part)+1));
  index  = (int*)R_alloc(sizeof(int),length(score)-first);
  
  n = length(part);
  for(i=first;i<length(score);i++) {
    double s = h<REAL(score)[i]?REAL(score)[i]:h;
    for(k=0;k<n;k++) if(s < REAL(part)[k]) break;
    counts[k]++;
    index[i-first] = k;
  }

  PROTECT(rings = allocVector(VECSXP,n+1));
  for(i=0;i<n+1;i++) {
    SEXP r;
    PROTECT(r = allocVector(INTSXP,counts[i]));
    SET_VECTOR_ELT(rings,i,r);
    UNPROTECT(1);
  }
  for(i=length(score)-1;i>=first;i--) {
    k = index[i-first];
    INTEGER(VECTOR_ELT(rings,k))[--counts[k]] = i;
  }
  SET_SLOT(ls,install("rings"),rings);
  vmaxset(vmax);
  UNPROTECT(2);
  return ls;
}
