#if 0
#include "fastdb.h"
#include <db.h>
#include "bitstring.h"

typedef struct _node {
  struct _node *next;
  int           vertex;
} node;

#define MOVE_ADD 1
#define MOVE_SUB 2
#define MOVE_REV 3

typedef struct {
  char type;
  int  i,j;
} move;

typedef struct {
  int    k,n;
  node **parents;
  node **children;
  node *freelist;
  node *cache;

  /* For doing cycle checking */
  int  *dcache;
  char *color;
} graph;


graph *create_graph(int k,int n) {
  graph* g = (graph*)R_alloc(sizeof(graph),1);

  g->parents  = (node**)R_alloc(sizeof(node*),n);
  g->children = (node**)R_alloc(sizeof(node*),n);
  g->cache    = (node*)R_alloc(sizeof(node),2*k*n);
  g->dcache   = (int*)R_alloc(sizeof(int),k*n);
  g->color    = (char*)R_alloc(sizeof(char),bitstr_size(n));
  g->k        = k;
  g->n        = n;
  for(i=0;i<(n*n)-1;i++) 
    cache[i].next = &cache[i+1];
  freelist = &cache[0];
  memset(g->children,0,sizeof(node*)*n);
  memset(g->parents,0,sizeof(node*)*n);
  memset(g->color,0,sizeof(char)*bitstr_size(n));
  return g;
}

int graph_has_path(graph*g,int i,j) {
  int dcn = 0;
  memset(g->color,0,sizeof(char)*bitstr_size(g->n));
  node *parent = g->parents[j];
  while(parent != NULL) {
    if(parent->vertex == i) return 1 else {
      g->dcache[dcn++] = parent->vertex;
      bitstr_set(g->color,parent->vertex);
    }
    parent = parent->next;
  }
  while(dcn) {
    int v = g->dcache[--dcn];
    parent = g->parents[v];
    while(parent != NULL) {
      if(parent->vertex == i) return 1 else {
	if(!bitstr_test(g->color,parent->vertex)) {
	  g->dcache[dcn++] = parent->vertex;
	  bitstr_set(g->color,parent->vertex);
	}
      }
      parent = parent->next;
    }
  }
  return 0;
}

SEXP graph_gen_sort(graph *g) {
  int i,dcn = 0;
  node *n;
  SEXP  order;
  PROTECT(order = allocVector(INTSXP,g->n));
  memset(g->color,0,sizeof(char)*bitstr_size(g->n));
  for(i=0;i<g->n;i++) {
    if(g->parents[i] == NULL) g->dcache[dcn++] = i;
  }
  UNPROTECT(1);
  return order;
}



SEXP BNSL_OrderDirectedSampler(SEXP  D,SEXP max_parents,
			       SEXP _N,SEXP order) {
  fast_score_ctx ctx = fast_ctx(D,INTEGER(max_parents));
  graph*         g   = create_graph(ctx->k,ctx->n);
  
}
#endif
