#include "common.h"

SEXP RandomPoset(int n) {
  SEXP p;
  int i;
  PROTECT(p = allocVector(RAWSXP,n+1));
  RAW(p)[0] = n;
  for(i=1;i<=n;i++) RAW(p)[i]=i;
  for(i=0;i<n;i++) {
    int j = i+unif_int(n-i);
    int t = RAW(p)[j+1];
    RAW(p)[j+1] = RAW(p)[i+1];
    RAW(p)[i+1] = t;
  }
  /* Place a poset partition at this location */
  for(i=1;i<n-1;i++) 
    if(unif_rand() < 0.5) RAW(p)[i] |= 0x80;
  UNPROTECT(1);
  return p;
}
SEXP BNSL_RandomPoset(SEXP n) {
  SEXP p;
  GetRNGstate();
  p = RandomPoset(INTEGER(n)[0]);
  PutRNGstate();
  return p;
}
SEXP BNSL_PrintPoset(SEXP poset) {
  unsigned char *p   = RAW(poset);
  int   i,n = p[0];
  for(i=1;i<=n;i++) 
    Rprintf("%d%c",p[i]&(0x7F),(p[i]&0x80)?'\n':' ');
  Rprintf("\n");
  return R_NilValue;
}

