#include "common.h"
#include "score_search.h"
#include "scoring.h"
#include "bitstring.h"

SEXP BNSL_GetWeightMatrix(SEXP samples) {
  SEXP orders = VECTOR_ELT(samples,0);
  SEXP scores = VECTOR_ELT(samples,1);
  int  i,j,n      = length(VECTOR_ELT(orders,0));
  SEXP res,dims;

  double norm = logsumexp(REAL(scores),length(scores));

  PROTECT(res = allocVector(REALSXP,n*n));
  PROTECT(dims = allocVector(REALSXP,2));
  REAL(dims)[0] = n;REAL(dims)[1] = n;
  setAttrib(res,R_DimSymbol,dims);
  memset(REAL(res),0,sizeof(double)*n*n);
  for(i=0;i<length(orders);i++) {
    SEXP order = VECTOR_ELT(orders,i);
    for(j=0;j<n;j++) {
      REAL(res)[j*n + INTEGER(order)[j]-1] += exp(REAL(scores)[i]-norm);
    }
  }
  UNPROTECT(2);
  return res;
}

SEXP BNSL_FeatureMatrix(SEXP d,SEXP max_parents,SEXP mode,
			SEXP order) {
  score_ctx ctx = bnsl_score_ctx(d,INTEGER(max_parents)[0],INTEGER(mode)[0]);
  SEXP    fm;
  double* nm = (double*)R_alloc(sizeof(double),ctx->n*ctx->n); 
  /* Normalizing const */
  PROTECT(fm = allocVector(REALSXP,ctx->n*ctx->n));   /* Feature Mat       */
  
  
  
  
}
