#ifndef _h_score_search_
#define _h_score_search_

#include <R_ext/RS.h>
#include <Rinternals.h>
#include <Rdefines.h>
#include <Rmath.h>
#include <sys/types.h>
#include <limits.h>
#include <db.h>
#include "bitstring.h"

void setdims(SEXP obj,int r,int c);
int      twiddle(int* x,int* y,int* z,int* p);
void inittwiddle(int,int,int*);
void get_db_info(SEXP,DB**,char**,int*);


#define BEGIN_DATABASE_ACCESS(X) { \
  DB   *db;DBT key,data;int n,r; \
  memset(&key,0,sizeof(DBT));  \
  memset(&data,0,sizeof(DBT)); \
  get_db_info((X),&db,(char**)&(key.data),&n); \
  key.size = bitstr_size(n)+1;

#define END_DATABASE_ACCESS }

#define N (n)
#define KEY_SIZE (key.size)

#define RESET_KEY memset(key.data,0,key.size)
#define KEY_SET_ELT(X) ((char*)key.data)[0] = (X)
#define KEY_PARENTS ((bitstr_t*)(((char*)key.data)+1))

#define SET_KEY_VALUE(V) key.data = V
#define DATABASE_LOOKUP if(((r = db->get(db,NULL,&key,&data,0) != 0) || data.size == 0)) { \
   error("%s:%d database lookup error for node %d (%s)",__FILE__,__LINE__,((char*)(key.data))[0],db_strerror(r)); \
}

#define DATABASE_LOOKUP_REF if(((r = db->get(db,NULL,key,data,0) != 0) || data->size == 0)) error("%s:%d database lookup error for node %d (%d)",__FILE__,__LINE__,((char*)(key->data))[0],r);

#define GET_SCORE_VALUE  ((double*)data.data)[0]
#define GET_SCORE_VALUE_REF ((double*)data->data)[0]
#endif
