#include "common.h"
#include "score_search.h"
#include "scoring.h"

SEXP    initialize_order(int*index,double*pdf,int n) {
  SEXP order;
  double cdf,ru;
  int i,t;
  PROTECT(order = allocVector(INTSXP,n));
  ru = unif_rand();cdf = 0.0;
  t  = 1;
  for(i=0;i<n;i++) {
    cdf += pdf[i];
    if(ru < cdf) {
      INTEGER(order)[0] = index[i++];
      break;
    } else 
      INTEGER(order)[t++] = index[i];
  }
  for(;i<n;i++) 
    INTEGER(order)[t++] = index[i];
  UNPROTECT(1);
  return order;
}

double* first_elt_pdf(SEXP sample) {
  SEXP orders = VECTOR_ELT(sample,0);
  int  n      = length(orders),v = length(VECTOR_ELT(orders,0));
  int  i;
  double* pdf = (double*)R_alloc(sizeof(double),v),invN = 1.0/(double)n;
  memset(pdf,0,sizeof(pdf)*v);
  for(i=0;i<n;i++) {
    SEXP order = VECTOR_ELT(orders,i);
    pdf[INTEGER(order)[0]-1] += invN;
  }
  return pdf;
}

SEXP BNSL_SequentialResample2(SEXP sample,
			      SEXP d,SEXP max_parents,SEXP mode,
			      SEXP temp,SEXP count) {
  score_ctx ctx = bnsl_score_ctx(d,INTEGER(max_parents)[0],
				 INTEGER(mode)[0]);
  double T = REAL(temp)[0],invT = 1.0/T;
  
}
