#include <R_ext/RS.h>
#include <Rmath.h>
#include "common.h"

extern int      twiddle(int* x,int* y,int* z,int* p);
extern void inittwiddle(int,int,int*);

extern char *Rf_EncodeElement(SEXP x, int indx, int quote);

SEXP BNSL_subapply(SEXP X,SEXP K,SEXP FUN,SEXP args) {
  SEXP R_fcall,ans,ind,tmp;
  int  i,n,x,y,z,t,k;
  int *p,*c;
  /*  if(!isSymbol(X) || !isSymbol(FUN))
      error("arguments must be symbolic");*/
  k = INTEGER(K)[0];
  n    = length(X);
  if(n == NA_INTEGER)
    error("invalid length");
  
  p = (int*)R_alloc(n+2,sizeof(int));
  c = (int*)R_alloc(n,  sizeof(int));


  ind  = allocVector(INTSXP,k); /* Allocate space for the subset */
  PROTECT(tmp     = LCONS(R_BracketSymbol,LCONS(X,LCONS(ind,R_NilValue))));
  PROTECT(R_fcall = LCONS(FUN,
			  length(args) > 0 ? LCONS(tmp,LCONS(args,R_NilValue)) 
			  : LCONS(tmp,R_NilValue)));
  PROTECT(ans     = allocVector(VECSXP,choose((double)n,(double)k)));
  inittwiddle(k,n,p);
  t=0;
  for(i=n-k;i<n;i++) {
    INTEGER(ind)[t++] = i+1;
  }
  t=0;
  while(!twiddle(&x,&y,&z,p)) {
    INTEGER(ind)[z] = x+1;
    SET_VECTOR_ELT(ans,t++,eval(R_fcall,R_GlobalEnv));
  }
  x=0;
  for(i=n-k;i<n;i++) {
    INTEGER(ind)[x++] = i+1;
  }
  SET_VECTOR_ELT(ans,t++,eval(R_fcall,R_GlobalEnv));
  UNPROTECT(3);
  return ans;
}

